diff --git a/src/effects/private/qgfxshaderbuilder.cpp b/src/effects/private/qgfxshaderbuilder.cpp
index d1902a2..22975b5 100644
--- a/src/effects/private/qgfxshaderbuilder.cpp
+++ b/src/effects/private/qgfxshaderbuilder.cpp
@@ -60,6 +60,7 @@
 #endif
 
 QGfxShaderBuilder::QGfxShaderBuilder()
+    : m_coreProfile(false)
 {
     // The following code makes the assumption that an OpenGL context the GUI
     // thread will get the same capabilities as the render thread's OpenGL
@@ -82,6 +83,7 @@ QGfxShaderBuilder::QGfxShaderBuilder()
             int components;
             gl->glGetIntegerv(GL_MAX_VARYING_COMPONENTS, &components);
             m_maxBlurSamples = components / 2.0;
+            m_coreProfile = context.format().profile() == QSurfaceFormat::CoreProfile;
         } else {
             int floats;
             gl->glGetIntegerv(GL_MAX_VARYING_FLOATS, &floats);
@@ -182,6 +184,15 @@ static void qgfx_declareBlurVaryings(QByteArray &shader, QGfxGaussSample *s, int
     }
 }
 
+static void qgfx_declareCoreBlur(QByteArray &shader, const QByteArray& direction, QGfxGaussSample *s, int samples)
+{
+    for (int i=0; i<samples; ++i) {
+        shader += direction + " vec2 ";
+        shader += s[i].name;
+        shader += ";\n";
+    }
+}
+
 static void qgfx_buildGaussSamplePoints(QGfxGaussSample *p, int samples, int radius, qreal deviation)
 {
 
@@ -259,6 +270,38 @@ QByteArray qgfx_gaussianVertexShader(QGfxGaussSample *p, int samples)
     return shader;
 }
 
+QByteArray qgfx_gaussianVertexCoreShader(QGfxGaussSample *p, int samples)
+{
+    QByteArray shader;
+    shader.reserve(1024);
+    shader += "#version 150 core\n"
+              "in vec4 qt_Vertex;\n"
+              "in vec2 qt_MultiTexCoord0;\n\n"
+              "uniform mat4 qt_Matrix;\n"
+              "uniform float spread;\n"
+              "uniform vec2 dirstep;\n\n";
+
+    qgfx_declareCoreBlur(shader, "out", p, samples);
+
+    shader += "\nvoid main() {\n"
+              "    gl_Position = qt_Matrix * qt_Vertex;\n\n";
+
+    for (int i=0; i<samples; ++i) {
+        shader += "    ";
+        shader += p[i].name;
+        shader += " = qt_MultiTexCoord0";
+        if (p[i].pos != 0.0) {
+            shader += " + spread * dirstep * float(";
+            shader += QByteArray::number(p[i].pos);
+            shader += ')';
+        }
+        shader += ";\n";
+    }
+
+    shader += "}\n";
+
+    return shader;
+}
 
 QByteArray qgfx_gaussianFragmentShader(QGfxGaussSample *p, int samples, bool alphaOnly)
 {
@@ -307,6 +350,182 @@ QByteArray qgfx_gaussianFragmentShader(QGfxGaussSample *p, int samples, bool alp
     return shader;
 }
 
+QByteArray qgfx_gaussianFragmentCoreShader(QGfxGaussSample *p, int samples, bool alphaOnly)
+{
+    QByteArray shader;
+    shader.reserve(1024);
+    shader += "#version 150 core\n"
+              "uniform sampler2D source;\n"
+              "uniform float qt_Opacity;\n";
+
+    if (alphaOnly) {
+        shader += "uniform vec4 color;\n"
+                  "uniform float thickness;\n";
+    }
+
+    shader += "out vec4 fragColor;\n";
+
+    qgfx_declareCoreBlur(shader, "in", p, samples);
+
+    shader += "\nvoid main() {\n"
+              "    fragColor = ";
+    if (alphaOnly)
+        shader += "mix(vec4(0), color, clamp((";
+    else
+        shader += "(";
+
+    qreal sum = 0;
+    for (int i=0; i<samples; ++i)
+        sum += p[i].weight;
+
+    for (int i=0; i<samples; ++i) {
+        shader += "\n                    + float(";
+        shader += QByteArray::number(p[i].weight / sum);
+        shader += ") * texture(source, ";
+        shader += p[i].name;
+        shader += ")";
+        if (alphaOnly)
+            shader += ".a";
+    }
+
+    shader += "\n                   )";
+    if (alphaOnly)
+        shader += "/thickness, 0.0, 1.0))";
+    shader += "* qt_Opacity;\n}";
+
+    return shader;
+}
+
+static QByteArray qgfx_fallbackVertexShader()
+{
+    return "attribute highp vec4 qt_Vertex;\n"
+           "attribute highp vec2 qt_MultiTexCoord0;\n"
+           "uniform highp mat4 qt_Matrix;\n"
+           "varying highp vec2 qt_TexCoord0;\n"
+           "void main() {\n"
+           "    gl_Position = qt_Matrix * qt_Vertex;\n"
+           "    qt_TexCoord0 = qt_MultiTexCoord0;\n"
+           "}\n";
+}
+
+static QByteArray qgfx_fallbackCoreVertexShader()
+{
+    return "#version 150 core\n"
+           "in vec4 qt_Vertex;\n"
+           "in vec2 qt_MultiTexCoord0;\n"
+           "uniform mat4 qt_Matrix;\n"
+           "out vec2 qt_TexCoord0;\n"
+           "void main() {\n"
+           "    gl_Position = qt_Matrix * qt_Vertex;\n"
+           "    qt_TexCoord0 = qt_MultiTexCoord0;\n"
+           "}\n";
+}
+
+static QByteArray qgfx_fallbackFragmentShader(int requestedRadius, qreal deviation, bool masked, bool alphaOnly)
+{
+    QByteArray fragShader;
+    if (masked)
+        fragShader += "uniform mediump sampler2D mask;\n";
+    fragShader +=
+        "uniform highp sampler2D source;\n"
+        "uniform lowp float qt_Opacity;\n"
+        "uniform mediump float spread;\n"
+        "uniform highp vec2 dirstep;\n";
+    if (alphaOnly) {
+        fragShader += "uniform lowp vec4 color;\n"
+                      "uniform lowp float thickness;\n";
+    }
+    fragShader +=
+        "\n"
+        "varying highp vec2 qt_TexCoord0;\n"
+        "\n"
+        "void main() {\n";
+    if (alphaOnly)
+        fragShader += "    mediump float result = 0.0;\n";
+    else
+        fragShader += "    mediump vec4 result = vec4(0);\n";
+    fragShader += "    highp vec2 pixelStep = dirstep * spread;\n";
+    if (masked)
+        fragShader += "    pixelStep *= texture2D(mask, qt_TexCoord0).a;\n";
+
+    float wSum = 0;
+    for (int r=-requestedRadius; r<=requestedRadius; ++r) {
+        float w = qgfx_gaussian(r, deviation);
+        wSum += w;
+        fragShader += "    result += float(";
+        fragShader += QByteArray::number(w);
+        fragShader += ") * texture2D(source, qt_TexCoord0 + pixelStep * float(";
+        fragShader += QByteArray::number(r);
+        fragShader += "))";
+        if (alphaOnly)
+            fragShader += ".a";
+        fragShader += ";\n";
+    }
+    fragShader += "    const mediump float wSum = float(";
+    fragShader += QByteArray::number(wSum);
+    fragShader += ");\n"
+        "    gl_FragColor = ";
+    if (alphaOnly)
+        fragShader += "mix(vec4(0), color, clamp((result / wSum) / thickness, 0.0, 1.0)) * qt_Opacity;\n";
+    else
+        fragShader += "(qt_Opacity / wSum) * result;\n";
+    fragShader += "}\n";
+
+    return fragShader;
+}
+
+static QByteArray qgfx_fallbackCoreFragmentShader(int requestedRadius, qreal deviation, bool masked, bool alphaOnly)
+{
+    QByteArray fragShader = "#version 150 core\n";
+    if (masked)
+        fragShader += "uniform sampler2D mask;\n";
+    fragShader +=
+        "uniform sampler2D source;\n"
+        "uniform float qt_Opacity;\n"
+        "uniform float spread;\n"
+        "uniform vec2 dirstep;\n";
+    if (alphaOnly) {
+        fragShader += "uniform vec4 color;\n"
+                      "uniform float thickness;\n";
+    }
+    fragShader +=
+        "out vec4 fragColor;\n"
+        "in vec2 qt_TexCoord0;\n"
+        "\n"
+        "void main() {\n";
+    if (alphaOnly)
+        fragShader += "    float result = 0.0;\n";
+    else
+        fragShader += "    vec4 result = vec4(0);\n";
+    fragShader += "    vec2 pixelStep = dirstep * spread;\n";
+    if (masked)
+        fragShader += "    pixelStep *= texture(mask, qt_TexCoord0).a;\n";
+
+    float wSum = 0;
+    for (int r=-requestedRadius; r<=requestedRadius; ++r) {
+        float w = qgfx_gaussian(r, deviation);
+        wSum += w;
+        fragShader += "    result += float(";
+        fragShader += QByteArray::number(w);
+        fragShader += ") * texture(source, qt_TexCoord0 + pixelStep * float(";
+        fragShader += QByteArray::number(r);
+        fragShader += "))";
+        if (alphaOnly)
+            fragShader += ".a";
+        fragShader += ";\n";
+    }
+    fragShader += "    const float wSum = float(";
+    fragShader += QByteArray::number(wSum);
+    fragShader += ");\n"
+        "    fragColor = ";
+    if (alphaOnly)
+        fragShader += "mix(vec4(0), color, clamp((result / wSum) / thickness, 0.0, 1.0)) * qt_Opacity;\n";
+    else
+        fragShader += "(qt_Opacity / wSum) * result;\n";
+    fragShader += "}\n";
+
+    return fragShader;
+}
 
 QVariantMap QGfxShaderBuilder::gaussianBlur(const QJSValue &parameters)
 {
@@ -323,73 +542,27 @@ QVariantMap QGfxShaderBuilder::gaussianBlur(const QJSValue &parameters)
     QVariantMap result;
 
     if (samples > m_maxBlurSamples || masked || fallback) {
-        QByteArray fragShader;
-        if (masked)
-            fragShader += "uniform mediump sampler2D mask;\n";
-        fragShader +=
-            "uniform highp sampler2D source;\n"
-            "uniform lowp float qt_Opacity;\n"
-            "uniform mediump float spread;\n"
-            "uniform highp vec2 dirstep;\n";
-        if (alphaOnly) {
-            fragShader += "uniform lowp vec4 color;\n"
-                          "uniform lowp float thickness;\n";
-        }
-        fragShader +=
-            "\n"
-            "varying highp vec2 qt_TexCoord0;\n"
-            "\n"
-            "void main() {\n";
-        if (alphaOnly)
-            fragShader += "    mediump float result = 0.0;\n";
-        else
-            fragShader += "    mediump vec4 result = vec4(0);\n";
-        fragShader += "    highp vec2 pixelStep = dirstep * spread;\n";
-        if (masked)
-            fragShader += "    pixelStep *= texture2D(mask, qt_TexCoord0).a;\n";
-
-        float wSum = 0;
-        for (int r=-requestedRadius; r<=requestedRadius; ++r) {
-            float w = qgfx_gaussian(r, deviation);
-            wSum += w;
-            fragShader += "    result += float(";
-            fragShader += QByteArray::number(w);
-            fragShader += ") * texture2D(source, qt_TexCoord0 + pixelStep * float(";
-            fragShader += QByteArray::number(r);
-            fragShader += "))";
-            if (alphaOnly)
-                fragShader += ".a";
-            fragShader += ";\n";
+
+        if (m_coreProfile) {
+            result[QStringLiteral("fragmentShader")] = qgfx_fallbackCoreFragmentShader(requestedRadius, deviation, masked, alphaOnly);
+            result[QStringLiteral("vertexShader")] = qgfx_fallbackCoreVertexShader();
+        } else {
+            result[QStringLiteral("fragmentShader")] = qgfx_fallbackFragmentShader(requestedRadius, deviation, masked, alphaOnly);
+            result[QStringLiteral("vertexShader")] = qgfx_fallbackVertexShader();
         }
-        fragShader += "    const mediump float wSum = float(";
-        fragShader += QByteArray::number(wSum);
-        fragShader += ");\n"
-            "    gl_FragColor = ";
-        if (alphaOnly)
-            fragShader += "mix(vec4(0), color, clamp((result / wSum) / thickness, 0.0, 1.0)) * qt_Opacity;\n";
-        else
-            fragShader += "(qt_Opacity / wSum) * result;\n";
-        fragShader += "}\n";
-        result[QStringLiteral("fragmentShader")] = fragShader;
-
-        result[QStringLiteral("vertexShader")] =
-            "attribute highp vec4 qt_Vertex;\n"
-            "attribute highp vec2 qt_MultiTexCoord0;\n"
-            "uniform highp mat4 qt_Matrix;\n"
-            "varying highp vec2 qt_TexCoord0;\n"
-            "void main() {\n"
-            "    gl_Position = qt_Matrix * qt_Vertex;\n"
-            "    qt_TexCoord0 = qt_MultiTexCoord0;\n"
-            "}\n";
         return result;
     }
 
     QVarLengthArray<QGfxGaussSample, 64> p(samples);
     qgfx_buildGaussSamplePoints(p.data(), samples, radius, deviation);
 
-    result[QStringLiteral("fragmentShader")] = qgfx_gaussianFragmentShader(p.data(), samples, alphaOnly);
-    result[QStringLiteral("vertexShader")] = qgfx_gaussianVertexShader(p.data(), samples);
-
+    if (m_coreProfile) {
+        result[QStringLiteral("fragmentShader")] = qgfx_gaussianFragmentCoreShader(p.data(), samples, alphaOnly);
+        result[QStringLiteral("vertexShader")] = qgfx_gaussianVertexCoreShader(p.data(), samples);
+    } else {
+        result[QStringLiteral("fragmentShader")] = qgfx_gaussianFragmentShader(p.data(), samples, alphaOnly);
+        result[QStringLiteral("vertexShader")] = qgfx_gaussianVertexShader(p.data(), samples);
+    }
     return result;
 }
 
diff --git a/src/effects/private/qgfxshaderbuilder_p.h b/src/effects/private/qgfxshaderbuilder_p.h
index 7061c7d..59aea2c 100644
--- a/src/effects/private/qgfxshaderbuilder_p.h
+++ b/src/effects/private/qgfxshaderbuilder_p.h
@@ -58,6 +58,7 @@ public:
 
 private:
     int m_maxBlurSamples = 0;
+    bool m_coreProfile;
 };
 
 QT_END_NAMESPACE
diff --git a/src/effects/qtgraphicaleffectsshaders.qrc b/src/effects/qtgraphicaleffectsshaders.qrc
new file mode 100644
index 0000000..98f8846
--- /dev/null
+++ b/src/effects/qtgraphicaleffectsshaders.qrc
@@ -0,0 +1,66 @@
+<RCC>
+    <qresource prefix="/qt-project.org/imports/QtGraphicalEffects">
+        <file>shaders/brightnesscontrast.frag</file>
+        <file>shaders/+glslcore/brightnesscontrast.frag</file>
+        <file>shaders/+glslcore/colorize.frag</file>
+        <file>shaders/colorize.frag</file>
+        <file>shaders/+glslcore/coloroverlay.frag</file>
+        <file>shaders/coloroverlay.frag</file>
+        <file>shaders/conicalgradient_nomask.frag</file>
+        <file>shaders/conicalgradient_mask.frag</file>
+        <file>shaders/+glslcore/conicalgradient_nomask.frag</file>
+        <file>shaders/+glslcore/conicalgradient_mask.frag</file>
+        <file>shaders/+glslcore/desaturate.frag</file>
+        <file>shaders/desaturate.frag</file>
+        <file>shaders/+glslcore/displace.frag</file>
+        <file>shaders/displace.frag</file>
+        <file>shaders/+glslcore/fastblur.frag</file>
+        <file>shaders/+glslcore/fastblur_internal.frag</file>
+        <file>shaders/+glslcore/fastblur_internal.vert</file>
+        <file>shaders/fastblur.frag</file>
+        <file>shaders/fastblur_internal.frag</file>
+        <file>shaders/fastblur_internal.vert</file>
+        <file>shaders/gammaadjust.frag</file>
+        <file>shaders/+glslcore/gammaadjust.frag</file>
+        <file>shaders/huesaturation.frag</file>
+        <file>shaders/+glslcore/huesaturation.frag</file>
+        <file>shaders/leveladjust.frag</file>
+        <file>shaders/+glslcore/leveladjust.frag</file>
+        <file>shaders/lineargradient.vert</file>
+        <file>shaders/lineargradient_nomask.frag</file>
+        <file>shaders/lineargradient_mask.frag</file>
+        <file>shaders/+glslcore/lineargradient.vert</file>
+        <file>shaders/+glslcore/lineargradient_nomask.frag</file>
+        <file>shaders/+glslcore/lineargradient_mask.frag</file>
+        <file>shaders/opacitymask.frag</file>
+        <file>shaders/+glslcore/opacitymask.frag</file>
+        <file>shaders/+glslcore/opacitymask_invert.frag</file>
+        <file>shaders/opacitymask_invert.frag</file>
+        <file>shaders/radialgradient_nomask.frag</file>
+        <file>shaders/radialgradient_mask.frag</file>
+        <file>shaders/radialgradient.vert</file>
+        <file>shaders/+glslcore/radialgradient_nomask.frag</file>
+        <file>shaders/+glslcore/radialgradient_mask.frag</file>
+        <file>shaders/+glslcore/radialgradient.vert</file>
+        <file>shaders/rectangularglow.frag</file>
+        <file>shaders/+glslcore/rectangularglow.frag</file>
+        <file>shaders/recursiveblur.frag</file>
+        <file>shaders/recursiveblur.vert</file>
+        <file>shaders/+glslcore/recursiveblur.frag</file>
+        <file>shaders/+glslcore/recursiveblur.vert</file>
+        <file>shaders/thresholdmask.frag</file>
+        <file>shaders/+glslcore/thresholdmask.frag</file>
+        <file>shaders/fastglow.frag</file>
+        <file>shaders/+glslcore/fastglow.frag</file>
+        <file>shaders/fastinnershadow_level0.frag</file>
+        <file>shaders/+glslcore/fastinnershadow_level0.frag</file>
+        <file>shaders/fastinnershadow.frag</file>
+        <file>shaders/+glslcore/fastinnershadow.frag</file>
+        <file>shaders/fastmaskedblur.frag</file>
+        <file>shaders/+glslcore/fastmaskedblur.frag</file>
+        <file>shaders/gaussianinnershadow.frag</file>
+        <file>shaders/gaussianinnershadow_shadow.frag</file>
+        <file>shaders/+glslcore/gaussianinnershadow.frag</file>
+        <file>shaders/+glslcore/gaussianinnershadow_shadow.frag</file>
+    </qresource>
+</RCC>
diff --git a/src/effects/shaders/+glslcore/brightnesscontrast.frag b/src/effects/shaders/+glslcore/brightnesscontrast.frag
new file mode 100644
index 0000000..414e268
--- /dev/null
+++ b/src/effects/shaders/+glslcore/brightnesscontrast.frag
@@ -0,0 +1,17 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform float brightness;
+uniform float contrast;
+out vec4 fragColor;
+
+void main() {
+    vec4 pixelColor = texture(source, qt_TexCoord0);
+    pixelColor.rgb /= max(1.0/256.0, pixelColor.a);
+    float c = 1.0 + contrast;
+    float contrastGainFactor = 1.0 + c * c * c * c * step(0.0, contrast);
+    pixelColor.rgb = ((pixelColor.rgb - 0.5) * (contrastGainFactor * contrast + 1.0)) + 0.5;
+    pixelColor.rgb = mix(pixelColor.rgb, vec3(step(0.0, brightness)), abs(brightness));
+    fragColor = vec4(pixelColor.rgb * pixelColor.a, pixelColor.a) * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/colorize.frag b/src/effects/shaders/+glslcore/colorize.frag
new file mode 100644
index 0000000..67496c6
--- /dev/null
+++ b/src/effects/shaders/+glslcore/colorize.frag
@@ -0,0 +1,60 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform float hue;
+uniform float saturation;
+uniform float lightness;
+out vec4 fragColor;
+
+float RGBtoL(vec3 color) {
+    float cmin = min(color.r, min(color.g, color.b));
+    float cmax = max(color.r, max(color.g, color.b));
+    float l = (cmin + cmax) / 2.0;
+    return l;
+}
+
+float hueToIntensity(float v1, float v2, float h) {
+    h = fract(h);
+    if (h < 1.0 / 6.0)
+        return v1 + (v2 - v1) * 6.0 * h;
+    else if (h < 1.0 / 2.0)
+        return v2;
+    else if (h < 2.0 / 3.0)
+        return v1 + (v2 - v1) * 6.0 * (2.0 / 3.0 - h);
+
+    return v1;
+}
+
+vec3 HSLtoRGB(vec3 color) {
+    float h = color.x;
+    float l = color.z;
+    float s = color.y;
+
+    if (s < 1.0 / 256.0)
+        return vec3(l, l, l);
+
+    float v1;
+    float v2;
+    if (l < 0.5)
+        v2 = l * (1.0 + s);
+    else
+        v2 = (l + s) - (s * l);
+
+    v1 = 2.0 * l - v2;
+
+    float d = 1.0 / 3.0;
+    float r = hueToIntensity(v1, v2, h + d);
+    float g = hueToIntensity(v1, v2, h);
+    float b = hueToIntensity(v1, v2, h - d);
+    return vec3(r, g, b);
+}
+
+void main() {
+    vec4 sample = texture(source, qt_TexCoord0);
+    sample = vec4(sample.rgb / max(1.0/256.0, sample.a), sample.a);
+    float light = RGBtoL(sample.rgb);
+    float c = step(0.0, lightness);
+    sample.rgb = HSLtoRGB(vec3(hue, saturation, mix(light, c, abs(lightness))));
+    fragColor = vec4(sample.rgb * sample.a, sample.a) * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/coloroverlay.frag b/src/effects/shaders/+glslcore/coloroverlay.frag
new file mode 100644
index 0000000..68c15ab
--- /dev/null
+++ b/src/effects/shaders/+glslcore/coloroverlay.frag
@@ -0,0 +1,10 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform vec4 color;
+out vec4 fragColor;
+void main() {
+    vec4 pixelColor = texture(source, qt_TexCoord0);
+    fragColor = vec4(mix(pixelColor.rgb/max(pixelColor.a, 0.00390625), color.rgb/max(color.a, 0.00390625), color.a) * pixelColor.a, pixelColor.a) * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/conicalgradient_mask.frag b/src/effects/shaders/+glslcore/conicalgradient_mask.frag
new file mode 100644
index 0000000..5724ebb
--- /dev/null
+++ b/src/effects/shaders/+glslcore/conicalgradient_mask.frag
@@ -0,0 +1,16 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform sampler2D gradientSource;
+uniform sampler2D maskSource;
+uniform float qt_Opacity;
+uniform float startAngle;
+uniform vec2 center;
+out vec4 fragColor;
+
+void main() {
+    float maskAlpha = texture(maskSource, qt_TexCoord0).a;
+    const float PI = 3.14159265;
+    const float PIx2inv = 0.1591549;
+    float a = (atan((center.y - qt_TexCoord0.t), (center.x - qt_TexCoord0.s)) + PI - startAngle) * PIx2inv;
+    fragColor = texture(gradientSource, vec2(0.0, fract(a))) * maskAlpha * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/conicalgradient_nomask.frag b/src/effects/shaders/+glslcore/conicalgradient_nomask.frag
new file mode 100644
index 0000000..89a3278
--- /dev/null
+++ b/src/effects/shaders/+glslcore/conicalgradient_nomask.frag
@@ -0,0 +1,14 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform sampler2D gradientSource;
+uniform float qt_Opacity;
+uniform float startAngle;
+uniform vec2 center;
+out vec4 fragColor;
+
+void main() {
+    const float PI = 3.14159265;
+    const float PIx2inv = 0.1591549;
+    float a = (atan((center.y - qt_TexCoord0.t), (center.x - qt_TexCoord0.s)) + PI - startAngle) * PIx2inv;
+    fragColor = texture(gradientSource, vec2(0.0, fract(a))) * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/desaturate.frag b/src/effects/shaders/+glslcore/desaturate.frag
new file mode 100644
index 0000000..c95c0a5
--- /dev/null
+++ b/src/effects/shaders/+glslcore/desaturate.frag
@@ -0,0 +1,11 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform float desaturation;
+out vec4 fragColor;
+void main(void) {
+    vec4 textureColor = texture(source, qt_TexCoord0.st);
+    float grayColor = (textureColor.r + textureColor.g + textureColor.b) / 3.0;
+    fragColor = mix(textureColor, vec4(vec3(grayColor), textureColor.a), desaturation) * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/displace.frag b/src/effects/shaders/+glslcore/displace.frag
new file mode 100644
index 0000000..0a1ba7c
--- /dev/null
+++ b/src/effects/shaders/+glslcore/displace.frag
@@ -0,0 +1,29 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform sampler2D displacementSource;
+uniform float displacement;
+uniform float xPixel;
+uniform float yPixel;
+out vec4 fragColor;
+
+float linearstep(float e0, float e1, float x) {
+    return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
+}
+
+void main() {
+    vec4 offset = texture(displacementSource, qt_TexCoord0);
+    offset.xy -= vec2(0.5, 0.5);
+    offset.xy = offset.xy * step(vec2(1.0/256.0), abs(offset.xy));
+    vec2 tx = qt_TexCoord0 + (vec2(-offset.x, offset.y) * displacement);
+
+    float e1 = linearstep(0.0, xPixel, tx.x);
+    float e2 = linearstep(0.0, yPixel, tx.y);
+    float e3 = 1.0 - linearstep(1.0, 1.0 + xPixel, tx.x);
+    float e4 = 1.0 - linearstep(1.0, 1.0 + yPixel, tx.y);
+
+    vec4 sample = texture(source, tx);
+    sample.rgb *= e1 * e2 * e3 * e4;
+    fragColor = sample * qt_Opacity * offset.a;
+}
diff --git a/src/effects/shaders/+glslcore/fastblur.frag b/src/effects/shaders/+glslcore/fastblur.frag
new file mode 100644
index 0000000..d80ba4e
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastblur.frag
@@ -0,0 +1,23 @@
+#version 150 core
+uniform sampler2D source1;
+uniform sampler2D source2;
+uniform sampler2D source3;
+uniform sampler2D source4;
+uniform sampler2D source5;
+uniform float weight1;
+uniform float weight2;
+uniform float weight3;
+uniform float weight4;
+uniform float weight5;
+uniform float qt_Opacity;
+in vec2 qt_TexCoord0;
+out vec4 fragColor;
+
+void main() {
+    vec4 sourceColor = texture(source1, qt_TexCoord0) * weight1;
+    sourceColor += texture(source2, qt_TexCoord0) * weight2;
+    sourceColor += texture(source3, qt_TexCoord0) * weight3;
+    sourceColor += texture(source4, qt_TexCoord0) * weight4;
+    sourceColor += texture(source5, qt_TexCoord0) * weight5;
+    fragColor = sourceColor * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/fastblur_internal.frag b/src/effects/shaders/+glslcore/fastblur_internal.frag
new file mode 100644
index 0000000..444e8ca
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastblur_internal.frag
@@ -0,0 +1,16 @@
+#version 150 core
+uniform sampler2D source;
+uniform float qt_Opacity;
+in vec2 qt_TexCoord0;
+in vec2 qt_TexCoord1;
+in vec2 qt_TexCoord2;
+in vec2 qt_TexCoord3;
+out vec4 fragColor;
+
+void main() {
+    vec4 sourceColor = (texture(source, qt_TexCoord0) +
+    texture(source, qt_TexCoord1) +
+    texture(source, qt_TexCoord2) +
+    texture(source, qt_TexCoord3)) * 0.25;
+    fragColor = sourceColor * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/fastblur_internal.vert b/src/effects/shaders/+glslcore/fastblur_internal.vert
new file mode 100644
index 0000000..1ceb9a2
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastblur_internal.vert
@@ -0,0 +1,18 @@
+#version 150 core
+in vec4 qt_Vertex;
+in vec2 qt_MultiTexCoord0;
+uniform mat4 qt_Matrix;
+uniform float yStep;
+uniform float xStep;
+out vec2 qt_TexCoord0;
+out vec2 qt_TexCoord1;
+out vec2 qt_TexCoord2;
+out vec2 qt_TexCoord3;
+
+void main() {
+    qt_TexCoord0 = vec2(qt_MultiTexCoord0.x + xStep, qt_MultiTexCoord0.y + yStep * 0.36);
+    qt_TexCoord1 = vec2(qt_MultiTexCoord0.x + xStep * 0.36, qt_MultiTexCoord0.y - yStep);
+    qt_TexCoord2 = vec2(qt_MultiTexCoord0.x - xStep * 0.36, qt_MultiTexCoord0.y + yStep);
+    qt_TexCoord3 = vec2(qt_MultiTexCoord0.x - xStep, qt_MultiTexCoord0.y - yStep * 0.36);
+    gl_Position = qt_Matrix * qt_Vertex;
+}
diff --git a/src/effects/shaders/+glslcore/fastglow.frag b/src/effects/shaders/+glslcore/fastglow.frag
new file mode 100644
index 0000000..4e18c45
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastglow.frag
@@ -0,0 +1,30 @@
+#version 150 core
+uniform sampler2D source1;
+uniform sampler2D source2;
+uniform sampler2D source3;
+uniform sampler2D source4;
+uniform sampler2D source5;
+uniform float weight1;
+uniform float weight2;
+uniform float weight3;
+uniform float weight4;
+uniform float weight5;
+uniform vec4 color;
+uniform float spread;
+uniform float qt_Opacity;
+in vec2 qt_TexCoord0;
+out vec4 fragColor;
+
+float linearstep(float e0, float e1, float x) {
+    return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
+}
+
+void main() {
+    vec4 sourceColor = texture(source1, qt_TexCoord0) * weight1;
+    sourceColor += texture(source2, qt_TexCoord0) * weight2;
+    sourceColor += texture(source3, qt_TexCoord0) * weight3;
+    sourceColor += texture(source4, qt_TexCoord0) * weight4;
+    sourceColor += texture(source5, qt_TexCoord0) * weight5;
+    sourceColor = mix(vec4(0), color, linearstep(0.0, spread, sourceColor.a));
+    fragColor = sourceColor * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/fastinnershadow.frag b/src/effects/shaders/+glslcore/fastinnershadow.frag
new file mode 100644
index 0000000..cf3f166
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastinnershadow.frag
@@ -0,0 +1,32 @@
+#version 150 core
+uniform sampler2D original;
+uniform sampler2D source1;
+uniform sampler2D source2;
+uniform sampler2D source3;
+uniform sampler2D source4;
+uniform sampler2D source5;
+uniform float weight1;
+uniform float weight2;
+uniform float weight3;
+uniform float weight4;
+uniform float weight5;
+uniform vec4 color;
+uniform float spread;
+uniform float qt_Opacity;
+in vec2 qt_TexCoord0;
+out vec4 fragColor;
+
+float linearstep(float e0, float e1, float x) {
+    return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
+}
+
+void main() {
+    vec4 shadowColor = texture(source1, qt_TexCoord0) * weight1;
+    shadowColor += texture(source2, qt_TexCoord0) * weight2;
+    shadowColor += texture(source3, qt_TexCoord0) * weight3;
+    shadowColor += texture(source4, qt_TexCoord0) * weight4;
+    shadowColor += texture(source5, qt_TexCoord0) * weight5;
+    vec4 originalColor = texture(original, qt_TexCoord0);
+    shadowColor.rgb = mix(originalColor.rgb, color.rgb * originalColor.a, linearstep(0.0, spread, shadowColor.a));
+    fragColor = vec4(shadowColor.rgb, originalColor.a) * originalColor.a * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/fastinnershadow_level0.frag b/src/effects/shaders/+glslcore/fastinnershadow_level0.frag
new file mode 100644
index 0000000..4449bb0
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastinnershadow_level0.frag
@@ -0,0 +1,15 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform vec4 color;
+uniform float horizontalOffset;
+uniform float verticalOffset;
+out vec4 fragColor;
+
+void main(void) {
+    vec2 pos = qt_TexCoord0 - vec2(horizontalOffset, verticalOffset);
+    float ea = step(0.0, pos.x) * step(0.0, pos.y) * step(pos.x, 1.0) * step(pos.y, 1.0);
+    float eb = 1.0 - ea;
+    fragColor = (eb * color + ea * color * (1.0 - texture(source, pos).a)) * qt_Opacity;
+}
diff --git a/src/effects/shaders/+glslcore/fastmaskedblur.frag b/src/effects/shaders/+glslcore/fastmaskedblur.frag
new file mode 100644
index 0000000..ae4d628
--- /dev/null
+++ b/src/effects/shaders/+glslcore/fastmaskedblur.frag
@@ -0,0 +1,53 @@
+#version 150 core
+uniform sampler2D mask;
+uniform sampler2D source1;
+uniform sampler2D source2;
+uniform sampler2D source3;
+uniform sampler2D source4;
+uniform sampler2D source5;
+uniform sampler2D source6;
+uniform float lod;
+uniform float qt_Opacity;
+in vec2 qt_TexCoord0;
+out vec4 fragColor;
+
+float weight(float v) {
+    if (v <= 0.0)
+        return 1.0;
+
+    if (v >= 0.5)
+        return 0.0;
+
+    return 1.0 - v * 2.0;
+}
+
+void main() {
+
+    vec4 maskColor = texture(mask, qt_TexCoord0);
+    float l = lod * maskColor.a;
+
+    float w1 = weight(abs(l - 0.100));
+    float w2 = weight(abs(l - 0.300));
+    float w3 = weight(abs(l - 0.500));
+    float w4 = weight(abs(l - 0.700));
+    float w5 = weight(abs(l - 0.900));
+    float w6 = weight(abs(l - 1.100));
+
+    float sum = w1 + w2 + w3 + w4 + w5 + w6;
+    float weight1 = w1 / sum;
+    float weight2 = w2 / sum;
+    float weight3 = w3 / sum;
+    float weight4 = w4 / sum;
+    float weight5 = w5 / sum;
+    float weight6 = w6 / sum;
+
+    vec4 sourceColor = texture(source1, qt_TexCoord0) * weight1;
+    sourceColor += texture(source2, qt_TexCoord0) * weight2;
+    sourceColor += texture(source3, qt_TexCoord0) * weight3;
+    sourceColor += texture(source4, qt_TexCoord0) * weight4;
+    sourceColor += texture(source5, qt_TexCoord0) * weight5;
+    sourceColor += texture(source6, qt_TexCoord0) * weight6;
+
+    fragColor = sourceColor * qt_Opacity;
+
+}
diff --git a/src/effects/shaders/+glslcore/gammaadjust.frag b/src/effects/shaders/+glslcore/gammaadjust.frag
new file mode 100644
index 0000000..7efdd89
--- /dev/null
+++ b/src/effects/shaders/+glslcore/gammaadjust.frag
@@ -0,0 +1,13 @@
+#version 150 core
+in vec2 qt_TexCoord0;
+uniform float qt_Opacity;
+uniform sampler2D source;
+uniform float gamma;
+out vec4 fragColor;
+
+void main(void) {
+    vec4 originalColor = texture(source, qt_TexCoord0.st);
+    originalColor.rgb = originalColor.rgb / max(1.0/256.0, originalColor.a);
+    vec3 adjustedColor = pow(originalColor.rgb, vec3(gamma));
+    fragColor = vec4(adjustedColor * originalColor.a, originalColor.a) * qt_Opacity;
+}
